rem @shift /0
@echo off
pushd "%~dp0"

rem :privilege
rem net session >nul 2>&1
rem if %errorlevel% neq 0 goto help

:param
if /i "%1"=="/u" goto remove

:fltsrv
set SrvName=fltsrv
echo.
echo -------------------- (1/5) Checking service: %SrvName% --------------------
sc query %SrvName%
if %errorlevel% equ 0 goto snapman
echo.
echo -------------------- (1/5) Creating service: %SrvName% --------------------
set DrvFile=System32\drivers\%SrvName%.sys
copy /y %DrvFile% "%SystemRoot%\System32\drivers\%SrvName%.sys"
if %errorlevel% neq 0 exit /b %errorlevel%
set RegKey=HKLM\SYSTEM\CurrentControlSet\Services\%SrvName%
reg add %RegKey% /f /v DisplayName  /t REG_SZ        /d "Acronis Storage Filter Management"
reg add %RegKey% /f /v ImagePath    /t REG_EXPAND_SZ /d System32\drivers\%SrvName%.sys
reg add %RegKey% /f /v ErrorControl /t REG_DWORD     /d 1
reg add %RegKey% /f /v Start        /t REG_DWORD     /d 0
reg add %RegKey% /f /v Type         /t REG_DWORD     /d 1
reg add %RegKey% /f /v Group        /t REG_SZ        /d "PnP Filter"
reg add %RegKey% /f /v Tag          /t REG_DWORD     /d 8
sc create %SrvName% type= kernel start= boot binpath= System32\drivers\%SrvName%.sys
if %errorlevel% neq 0 exit /b %errorlevel%
echo.
echo -------------------- (1/5) Starting service: %SrvName% -------------------- 
sc start %SrvName%
if %errorlevel% neq 0 exit /b %errorlevel%

:snapman
set SrvName=snapman
echo.
echo -------------------- (2/5) Checking service: %SrvName% --------------------
sc query %SrvName%
if %errorlevel% equ 0 goto volume_tracker
echo.
echo -------------------- (2/5) Creating service: %SrvName% --------------------
set DrvFile=System32\drivers\%SrvName%.sys
copy /y %DrvFile% "%SystemRoot%\System32\drivers\%SrvName%.sys"
if %errorlevel% neq 0 exit /b %errorlevel%
set DrvFile=System32\snapapi*.*
copy /y %DrvFile% "%SystemRoot%\System32\"
if %errorlevel% neq 0 exit /b %errorlevel%
set RegKey=HKLM\SYSTEM\CurrentControlSet\Services\%SrvName%
reg add %RegKey% /f /v DisplayName  /t REG_SZ        /d "Acronis Snapshot Manager"
reg add %RegKey% /f /v ImagePath    /t REG_EXPAND_SZ /d System32\drivers\%SrvName%.sys
reg add %RegKey% /f /v ErrorControl /t REG_DWORD     /d 1
reg add %RegKey% /f /v Start        /t REG_DWORD     /d 0
reg add %RegKey% /f /v Type         /t REG_DWORD     /d 1
sc create %SrvName% type= kernel start= boot binpath= System32\drivers\%SrvName%.sys
if %errorlevel% neq 0 exit /b %errorlevel%
echo.
echo -------------------- (2/5) Starting service: %SrvName% -------------------- 
sc start %SrvName%
if %errorlevel% neq 0 exit /b %errorlevel%

:volume_tracker
set SrvName=volume_tracker
echo.
echo -------------------- (3/5) Checking service: %SrvName% --------------------
sc query %SrvName%
if %errorlevel% equ 0 goto filter
echo.
echo -------------------- (3/5) Creating service: %SrvName% --------------------
set DrvFile=System32\drivers\%SrvName%.sys
copy /y %DrvFile% "%SystemRoot%\System32\drivers\%SrvName%.sys"
if %errorlevel% neq 0 exit /b %errorlevel%
set DrvFile=System32\volume_tracker*.*
copy /y %DrvFile% "%SystemRoot%\System32\"
if %errorlevel% neq 0 exit /b %errorlevel%
set RegKey=HKLM\SYSTEM\CurrentControlSet\Services\%SrvName%
reg add %RegKey% /f /v DisplayName  /t REG_SZ        /d "Acronis Volume Tracker"
reg add %RegKey% /f /v ImagePath    /t REG_EXPAND_SZ /d System32\drivers\%SrvName%.sys
reg add %RegKey% /f /v ErrorControl /t REG_DWORD     /d 1
reg add %RegKey% /f /v Start        /t REG_DWORD     /d 0
reg add %RegKey% /f /v Type         /t REG_DWORD     /d 1
reg add %RegKey% /f /v Group        /t REG_SZ        /d "PnP Filter"
sc create %SrvName% type= kernel start= boot binpath= System32\drivers\%SrvName%.sys
if %errorlevel% neq 0 exit /b %errorlevel%
echo.
echo -------------------- (3/5) Starting service: %SrvName% -------------------- 
sc start %SrvName%
if %errorlevel% neq 0 exit /b %errorlevel%

:filter
echo.
echo -------------------- (4/5) Installing disk drive filters --------------------
set RegKey1=HKLM\SYSTEM\CurrentControlSet\Control\Class\{4d36e967-e325-11ce-bfc1-08002be10318}
set RegKey2=HKLM\SYSTEM\CurrentControlSet\Control\Class\{71a27cdd-812a-11d0-bec7-08002be2092f}
set RegValue=UpperFilters
set RegKey=%RegKey1%
set RegData=
for /f "tokens=3" %%I in ('reg query %RegKey% /v %RegValue%') do (set RegData=%%I)
echo "%RegData%" | findstr /i fltsrv >nul
if %errorlevel% equ 0 goto filter2
set NewData=%RegData%\0fltsrv
if "%NewData:~0,2%"=="\0" set NewData=%NewData:~2%
reg add %RegKey% /f /v %RegValue% /t REG_MULTI_SZ /d "%NewData%"
:filter2
set RegKey=%RegKey2%
set RegData=
for /f "tokens=3" %%I in ('reg query %RegKey% /v %RegValue%') do (set RegData=%%I)
echo "%RegData%" | findstr /i fltsrv >nul
if %errorlevel% equ 0 goto print
set NewData=%RegData%\0fltsrv
if "%NewData:~0,2%"=="\0" set NewData=%NewData:~2%
reg add %RegKey% /f /v %RegValue% /t REG_MULTI_SZ /d "%NewData%"
:print
reg query %RegKey1% /v %RegValue%
reg query %RegKey2% /v %RegValue%

:registry
echo.
echo -------------------- (5/5) Creating registry keys and values --------------------
set RegKey=HKLM\SOFTWARE\Acronis
reg add %RegKey%\TrueImage              /f /v standard   /t REG_SZ /d " 19 98 19 25 99 98108  1120102 19  6 23 18  6 98 22120 19 25  1 30 30 27 30 23120 20 22  6 30 25 99 19 19120 13  0 30 18 16 20 23  4120 30 97  4 22 15  4  2 18120 31  0 19  3 27  2  5  2120  1  7  6109108102  0109"
reg add %RegKey%\TrueImageHome\Settings /f /v ServiceDir /t REG_SZ /d "%~dp0"
for %%I in (snapapi.dll volume_tracker_driver_api.dll) do (
  reg add %RegKey%\GlobalComponents     /f /v %%I        /t REG_SZ /d "%SystemRoot%\System32\%%I"
)
for %%I in (archive3 archive3_adapter astor_client boot_assist disk_backup expat file_backup icu38 kb_link libcrypto10 libssl10 logging mspack oem_doc_source onig pcs_io re2 resource rpc_client thread_pool tib_api tib_mounter ulxmlrpcpp winpthreads4 zstd) do (
  reg add %RegKey%\CommonComponents     /f /v %%I.dll    /t REG_SZ /d "%~dp0%%I.dll"
)
for %%I in (backup_worker.exe) do (
  reg add %RegKey%\CommonComponents     /f /v %%I        /t REG_SZ /d "%~dp0%%I"
)

:run
if /i "%1"=="/i" goto end
if /i "%1"=="/u" goto end
start TrueImage.exe

:end
exit /b 0

rem :help
rem echo.
rem echo Administrator privileges required.
rem echo Please right click "%~nx0" and choose "Run as administrator".
rem echo.
rem if [%1]==[] pause
rem exit /b 5

:remove
echo -------------------- (1/3) Removing disk drive filters --------------------
set RegKey1=HKLM\SYSTEM\CurrentControlSet\Control\Class\{4d36e967-e325-11ce-bfc1-08002be10318}
set RegKey2=HKLM\SYSTEM\CurrentControlSet\Control\Class\{71a27cdd-812a-11d0-bec7-08002be2092f}
set RegValue=UpperFilters
set RegKey=%RegKey1%
set RegData=fltsrv
for /f "tokens=3" %%I in ('reg query %RegKey% /v %RegValue%') do (set RegData=%%I)
set NewData=%RegData:\0fltsrv=%
set NewData=%NewData:fltsrv\0=%
set NewData=%NewData:fltsrv=%
if not "%NewData%"=="%RegData%" reg add %RegKey% /f /v %RegValue% /t REG_MULTI_SZ /d "%NewData%"
set RegKey=%RegKey2%
set RegData=fltsrv
for /f "tokens=3" %%I in ('reg query %RegKey% /v %RegValue%') do (set RegData=%%I)
set NewData=%RegData:\0fltsrv=%
set NewData=%NewData:fltsrv\0=%
set NewData=%NewData:fltsrv=%
if not "%NewData%"=="%RegData%" reg add %RegKey% /f /v %RegValue% /t REG_MULTI_SZ /d "%NewData%"
reg query %RegKey1% /v %RegValue%
reg query %RegKey2% /v %RegValue%
echo.
echo -------------------- (2/3) Removing services --------------------
for %%I in (volume_tracker snapman fltsrv) do (
  sc stop   %%I
  sc delete %%I
)
echo.
echo -------------------- (3/3) Removing registry keys and values --------------------
reg delete HKCU\SOFTWARE\Acronis /f >nul 2>&1
reg delete HKLM\SOFTWARE\Acronis /f
echo.
echo -------------------- Uninstall finished. Please reboot your computer --------------------
echo.
exit /b 0

